' -----------------------------------------------------
' Phantasie II
' Load dungeons data
' -----------------------------------------------------
' Decoded and commented by Franck Charlet
' -----------------------------------------------------

load_dungeon:

    SA = 16385
    on err goto err_handler

err_handler:

    home
    vtab 23
    htab 15
    print "PLEASE WAIT"
    print
    &recall "DNGCHK"                ' Load at 0x3be / 958 (or is it 0x44A8 / 17576)
    new_dungeon = peek(SA + 1191)
    if peek(CURRENT_DUNGEON) <> new_dungeon then
        goto lbl_200
    end if
    &recall "DNGSAV"                ' Load at 0x802 / 2050
    for X = 2050 to 3303            ' Check 1253 bytes
        if peek(X) < 185 then
            goto lbl_150
        end if
        E = peek(X)
        if E = 185 or E = 200 then
            goto lbl_120
        end if
        if E = 199 or E = 214 then
            poke X, E - 1
        end if
        goto lbl_150

lbl_120:

        if (rnd(1) < .4) and (new_dungeon <> 7) then
            poke X, E + 13
        end if

lbl_150:

    next
    goto lbl_320

lbl_200:

    hcolor = 3
    hplot 0, 0 to 139, 0
    hplot 0, 159 to 139, 159
    for Y = 0 to 159
        hplot 138, Y to 279, Y
    next

lbl_320:

    if peek(CURRENT_DUNGEON) = new_dungeon then
        goto dont_reload_dungeon
    end if
    &recall "DNG" + str$(new_dungeon)

dont_reload_dungeon:

    &run "DUNGON"
