' -----------------------------------------------------
' Phantasie II
' Dungeons
' -----------------------------------------------------
' Decoded and commented by Franck Charlet
' -----------------------------------------------------

init_dungeon:

    S$ = "+-------------------------------------+"
    on err goto lbl_9500
    SA = 16385
    Y%(0) = 135
    def fn O(X) = SA + 170 * WG + X
    def fn W(X) = peek(SA + 170 * WG + X)
    def get_character_data(X) = peek(SA + 170 * PM + X)
    def character_data_address(X) = SA + 170 * PM + X
    def fn L(X) = peek(SA + PARTY_GLOBAL_LEVEL)
    def fn D(X) = (2 ^ X * int(MF / 2 ^ X)) <> (2 ^ (X - 1) * int(MF / 2 ^ (X - 1)))
    for X = 0 to 8
        read monsters_items_list(X)
    next
    data "SHIELD", "ARMOR", "WEAPON", "GOOD WEAPON", "MAGIC WEAPON", "POTION", "SCROLL", "TREASURE", "GOOD TREASURE"
    S$(0) = "DEAD"
    S$(1) = "OKAY"
    S$(2) = "SLEEP"

    gods_list(3) = "ZEUS"
    gods_list(0) = "A DEMIGOD"
    gods_list(1) = "ATHENA"
    gods_list(2) = "APOLLO"

    rot = 0
    cur_characters = peek(SA + CHARACTERS_IN_PARTY)
    for PM = 0 to 6
        for X = 131 to 141
            character_names(PM) = character_names(PM) + chr$(get_character_data(X))
        next
    next
    PA = peek(SA + 1204) * 120
    NS = peek(SA + 1205)
    LA = 2050
    def get_dungeon_tile_data(Z) = peek(LA + Y * 33 + X)
    def get_dungeon_tile_address(Z) = LA + 33 * CY + CX
    FE = 6 + 3 * (peek(CURRENT_DUNGEON) = peek(SA + 1191))
    ' dungeon level
    VL = peek(LA + 1255)
    goto enter_dungeon

' -----------------------------------------------------
start_encounter_system:

    print
    MG = 0
    LV = 0
    GL = 0
    MS = 0
    MP = 0
    YS = 0
    AK = 0
    DA = 0
    SP = 0
    RN%(0) = 0
    RN%(1) = 1
    RN%(2) = 2
    GN%(1) = -1
    GN%(2) = -1
    gosub init_temp_characters_values
    PM = 6
    poke character_data_address(CHARACTER_STATUS), CHARACTER_STATUS_OKAY
    MQ = 0
    QM = 0
    print "AN ENCOUNTER"

lbl_900:

    CA = 0
    EX = 0
    MF = int(MO / 8)
    EF = MO - MF * 8
    &read "MN2" + str$(MF)
    for H = 0 to EF
        input N$(MG), MA%(MG), DM%(MG), TM, EX(MG), SL%(MG), SP%(MG, 0), SP%(MG, 1), SP%(MG, 2), DM, PW%(MG), WG, ML, C%(MG), H%(MG), PM, PL, D%(MG), X, Y, YS%(MG), ZA, ZB, AK%(MG), S%(MG)
    next H
    &end
    if MG = 0 then
        IA = ZA
        IB = ZB
    end if
    if PM > -11 then
        goto lbl_920
    end if
    MQ = -10 - PM
    for PM = 0 to cur_characters
        MF = get_character_data(CHARACTER_AMULETS)
        QM = QM + fn D(MQ)
    next
    if QM = 0 then
        home
        vtab 23
        print "ENC" ; chr$(7) ; "OUN" ; chr$(7) ; "TER" ; chr$(7) ; " WI" ; chr$(7) ; "TH " ; chr$(7) ; "ONE" ; chr$(7) ; " OF" ; chr$(7) ; " PL" ; chr$(7) ; "UTO" ; chr$(7) ; "'S " ; chr$(7) ; "MIN" ; chr$(7) ; "ION" ; chr$(7) ; "S!"
        for PS = 1 to 7000
        next
        goto lbl_920
    end if
    SU = 1
    SM = 1
    MO = int(rnd(1) * 36)
    goto start_encounter_system

lbl_920:

    GN%(MG) = int(rnd(1) * Y)
    for Y = 0 to GN%(MG)
        HP%(MG, Y) = (.5 + rnd(1)) * DM + .5
        ST%(MG, Y) = 3 - SM
        GL = GL + X
    next
    LV = LV + TM
    NF = NF + PM
    if MG = 2 or rnd(1) * 100 > PL then
        goto lbl_980
    end if
    MG = MG + 1
    MO = WG
    if rnd(1) < .5 then
        MO = ML
    end if
    goto lbl_900

lbl_980:

    LV = LV / (MG + 1)
    NF = NF / (MG + 1)
    PL = cur_characters
    if SU = 1 then
        goto lbl_1480
    end if

lbl_1000:

    text
    home
    print "#  NAME     ATTACKS MAGIC HIT PTS STATUS"
    print
    PL = -1
    AP = -1
    for PM = 0 to cur_characters
        vtab PM + 2
        print PM + 1 " " character_names(PM) tab(16) int(get_character_data(58) / 75 + 1) tab(21) get_character_data(11) "/" get_character_data(10) tab(27) get_character_data(13) "/" get_character_data(12) tab(36) S$(get_character_data(18))
        if get_character_data(18) = 0 then
            goto lbl_1016
        end if
        PL = PL + 1
        P%(PL) = PM
        AP = AP + 2 - get_character_data(18)

lbl_1016:

    next
    if PL = -1 then
        goto go_cemetary
    end if
    hcolor = 0
    vtab 9
    print S$
    DM = 0
    for X = 0 to MG
        ML = -1
        scale = C%(X)
        for Y = 0 to GN%(X)
            draw S%(X) at X%(X, Y), Y%(X)
            draw S%(X) + 1 at X%(X, Y), Y%(X)
            if HP%(X, Y) < 1 then
                goto lbl_1046
            end if
            TR = X
            ML = ML + 1
            HP%(X, ML) = HP%(X, Y)
            if ST%(X, Y) > 1 and SM <> 1 then
                ST%(X, ML) = 3
            end if
            ST%(X, ML) = ST%(X, Y)

lbl_1046:

        next Y
        GN%(X) = ML
        DM = DM + ML + 1
    next X
    SM = 0
    FG = 2
    SG = 2
    TG = 2
    HM = -1
    LM = -1
    for X = 0 to 2
        if GN%(X) >= HM then
            TG = SG
            SG = FG
            LM = HM
            FG = X
            HM = GN%(X)
            goto lbl_1050
        end if
        if GN%(X) >= LM then
            TG = SG
            SG = X
            LM = GN%(X)
            goto lbl_1050
        end if
        TG = X

lbl_1050:

    next
    RN%(0) = FG
    RN%(1) = SG
    RN%(2) = TG
    for Q = 0 to MG
        X = RN%(Q)
        if GN%(X) > -1 then
            print " RANK " Q + 1 "  " GN%(X) + 1 " " N$(X) "(S)"
        end if
    next
    vtab 13
    print S$
    hcolor = 3
    hplot 0, 0 to 138, 0
    poke -16368, 0
    if DM = 0 then
        AK = 1
        goto lbl_4260
    end if
    if MP = 2 then
        goto lbl_4260
    end if
    if MP = 1 then
        goto lbl_4220
    end if
    if EX / EX(0) * (1 + rnd(1)) < DM * (2 + rnd(1)) then
        goto lbl_1068
    end if
    print tab(10) "MONSTERS " chr$(7 - NS) "RUN"
    for PS = 1 to 3 * PA
    next
    if rnd(1) * 100 < 80 - 5 * DM then
        goto lbl_4260
    end if
    for X = 0 to MG
        for Y = 0 to GN%(X)
            ST%(X, Y) = 2
        next
    next

lbl_1068:

    poke 34, 15
    vtab 17
    print "PARTY OPTIONS 1)FIGHT 2)ACCEPT SURRENDER  3)GREETINGS  4)BEG FOR MERCY  5)FLEE" ;
    get A$
    J = val(A$)
    print
    print
    on J goto lbl_1200, lbl_1137, lbl_1150, lbl_1110, lbl_1090
    home
    goto lbl_1068

lbl_1090:

    if rnd(1) * 100 < 80 - 5 * cur_characters and (PL - AP) < .3 * (PL + 1) then
        goto lbl_4220
    end if
    for PM = 0 to cur_characters
        IN%(PM) = 4
    next
    goto lbl_1480

lbl_1110:

    if rnd(1) * 100 < 60 + 3 * NF then
        goto lbl_1130
    end if

lbl_1120:

    print "THE MONSTERS DON'T RESPOND"
    for PS = 1 to 1500
    next
    goto lbl_1200

lbl_1130:

    print "THE MONSTERS STOP AND TAKE YOUR GOLD"
    GL = -256 * peek(SA + 1199)
    YS = 1
    CX = OX
    CY = OY
    goto lbl_4260

lbl_1137:

    if rnd(1) * 100 > EX / EX(0) * 15 + 2 * fn L(0) - 3 * LV then
        goto lbl_1120
    end if
    print "THE MONSTERS SURRENDER"
    goto lbl_4250

lbl_1150:

    if rnd(1) * 100 * (1 - CA) < 90 - NF then
        goto lbl_1120
    end if
    print "THE MONSTERS GREET YOU"
    goto lbl_4240

lbl_1200:

    home
    print "INDV. OPTIONS: 1)THRUST 2)ATTACK 3)SLASH4)LUNGE 5)SPELL 6)PARRY  7)TOSS  8)REDO"
    poke 34, 18

lbl_1210:

    home
    for PM = 0 to cur_characters
        if get_character_data(18) <> 1 then
            goto lbl_1450
        end if
        goto lbl_1220

lbl_1215:

        print

lbl_1220:

        print character_names(PM) ;

lbl_1225:

        get A$
        IN = val(A$)
        on IN goto lbl_1235, lbl_1236, lbl_1238, lbl_1231, lbl_1310, lbl_1430, lbl_1452, lbl_1210
        goto lbl_1225

lbl_1231:

        if get_character_data(151) <> 0 and get_character_data(151) <> 3 then
            goto lbl_1225
        end if
        print " LUNGE"
        IN%(PM) = 11
        goto lbl_1460

lbl_1235:

        print " THRUST " ;
        TM = 1
        goto lbl_1240

lbl_1236:

        if get_character_data(58) < 75 then
            goto lbl_1235
        end if
        print " ATTACK " ;
        TM = 2
        goto lbl_1240

lbl_1238:

        if get_character_data(58) < 150 then
            goto lbl_1236
        end if
        print " SLASH " ;
        TM = int(1 + get_character_data(58) / 75)

lbl_1240:

        WG = 1
        if MG < 1 or GN%(TR) = DM - 1 or get_character_data(151) > 0 then
            print
            goto lbl_1300
        end if
        if TM <> 2 then
            print "AT " ;
        end if
        print "RANK " ;
        get A$
        WG = val(A$)
        if WG > MG + 1 or WG = 0 then
            goto lbl_1215
        end if
        print WG

lbl_1300:

        IN%(PM) = TM * 10 + WG - 1
        goto lbl_1460

lbl_1310:

        input " CAST SPELL #" ; WG
        if WG < 1 or WG > 51 then
            goto lbl_1220
        end if
        if get_character_data(WG + 60) = 1 then
            goto lbl_1350
        end if
        print " SPELL NOT KNOWN"
        goto lbl_1220

lbl_1350:

        if get_character_data(11) >= WG - 4 * int((WG - 1) / 4) then
            goto lbl_1370
        end if
        print " NOT ENOUGH MAGIC"
        goto lbl_1220

lbl_1370:

        IN%(PM) = 100 + WG
        if WG > 4 then
            goto lbl_1420
        end if
        print " ON PERSON #" ;
        get A$
        TM = val(A$)
        if TM = 0 or TM > cur_characters + 1 then
            goto lbl_1215
        end if
        print TM ;
        IN%(PM) = 1000 * WG + TM - 1

lbl_1420:

        print
        goto lbl_1460

lbl_1430:

        print " PARRY"
        if rnd(1) * 100 > get_character_data(22) then
            goto lbl_1450
        end if
        IN%(PM) = 3
        goto lbl_1460

lbl_1450:

        IN%(PM) = 4
        goto lbl_1460

lbl_1452:

        if MG = 0 then
            print " TOSS"
            IN%(PM) = -1
            goto lbl_1460
        end if
        print " TOSS AT RANK " ;

lbl_1454:

        get A$
        X = val(A$)
        IN%(PM) = -1 * X
        if X < 1 or X > MG + 1 then
            goto lbl_1454
        end if
        print X

lbl_1460:

    next PM
    print
    print "REDO (Y/N)" ;
    get A$
    if A$ = "Y" then
        goto lbl_1200
    end if

lbl_1480:

    Y%(RN%(0)) = 135
    SM = 0
    Y%(RN%(1)) = 135 - YS%(RN%(0))
    X = Y%(RN%(1)) - YS%(RN%(1))
    Y%(RN%(2)) = X * (X > 0)
    gosub sub_1525
    goto lbl_1540

sub_1525:

    scale = 1
    for PM = 0 to cur_characters
        hcolor = 0
        for TM = 20 to 22
            draw TM at PM * 19, 158
        next
        draw get_character_data(168) at PM * 19, 158
        if get_character_data(18) = 0 then
            goto lbl_1536
        end if
        hcolor = 3
        draw get_character_data(168) at PM * 19, 158
        if IN%(PM) = 3 then
            draw 21 at PM * 19, 158
            goto lbl_1536
        end if
        draw 20 at 19 * PM, 158

lbl_1536:

    next
    return

lbl_1540:

    for X = 0 to MG
        scale = C%(X)
        hcolor = H%(X)
        if GN%(X) = -1 then
            goto lbl_1552
        end if
        for Y = 0 to GN%(X)
            X%(X, Y) = H%(X) + Y * 120 / (GN%(X) + 1)
            draw S%(X) at X%(X, Y), Y%(X)
        next

lbl_1552:

    next
    print
    poke -16304, 0
    poke 34, 20
    for SR = 1 to 5 step 2
        for PM = 0 to cur_characters
            scale = 1
            home
            if IN%(PM) > 4 then
                goto lbl_1660
            end if
            if IN%(PM) > -1 then
                goto lbl_1630
            end if
            print character_names(PM) " THROWS A ROCK"
            gosub sub_1760
            WG = RN%(-1 * IN%(PM) - 1)
            gosub sub_1691
            if TZ < 5 then
                goto lbl_1628
            end if
            if rnd(1) * 100 > get_character_data(CHARACTER_SKILL_TOSS_ROCK) then
                goto lbl_1628
            end if
            DM = 12 * rnd(1) - MA%(WG)
            DM = DM * (DM > 0) + get_character_data(CHARACTER_SKILL_WEAPON) * rnd(1)
            SP = 2
            gosub sub_4100
            goto lbl_1835

lbl_1628:

            print character_names(PM) " MISSES"
            scale = 1
            hcolor = 3
            xdraw 59 at 70, 20
            D = peek(-16336 - NS) + peek(-16336 - NS)
            for PS = 1 to 250
            next
            xdraw 59 at 70, 20
            gosub lbl_4150
            goto lbl_1835

lbl_1630:

            if get_character_data(18) <> 2 then
                goto lbl_1840
            end if
            if rnd(1) > .16 then
                goto lbl_1840
            end if
            print character_names(PM) " AWAKENS"
            poke character_data_address(CHARACTER_STATUS), CHARACTER_STATUS_OKAY
            for PS = 1 to PA
            next
            goto lbl_1840

lbl_1660:

            if 3 * get_character_data(54) + 5 * SR * SR < rnd(1) * 100 then
                goto lbl_1840
            end if
            if IN%(PM) > 90 then
                goto lbl_1750
            end if
            TM = int(IN%(PM) / 10)
            WG = IN%(PM) - TM * 10
            WG = RN%(WG)
            for Y = 1 to TM
                home
                gosub sub_1691
                goto lbl_1694

sub_1691:

                for TZ = 0 to 2
                    MN = int((PM + rnd(1) * 2) / (cur_characters + 2) * (GN%(WG) + 1))
                    if HP%(WG, MN) > 0 then
                        TZ = 5
                    end if
                next TZ
                return

lbl_1694:

                if TZ < 5 then
                    goto lbl_1740
                end if
                scale = 1
                hcolor = 0
                draw 20 at PM * 19, 158
                hcolor = 3
                draw 22 at PM * 19, 158
                if rnd(1) * 100 < get_character_data(58) / TM - D%(WG) or ST%(WG, MN) = 1 then
                    goto lbl_1710
                end if
                print character_names(PM) " MISSES"
                P1 = 1
                P2 = 1
                P3 = 1
                P4 = 3
                D1 = 1
                D2 = 1
                D3 = 1
                D4 = 100
                gosub sub_7570
                for PS = 1 to PA
                next
                goto lbl_1740

lbl_1710:

                print character_names(PM) " HITS "
                DM = int(rnd(1) ^ .5 * get_character_data(57) - MA%(WG) + 3 - IN%(PM) / 6.7)
                if MN < 0 then
                    MN = 0
                end if
                gosub sub_4100

lbl_1740:

            next Y
            goto lbl_1835

lbl_1750:

            print character_names(PM) " CASTS A SPELL"
            SQ = IN%(PM)
            gosub sub_1760
            goto lbl_1762

sub_1760:

            hcolor = 0
            draw 20 at PM * 19, 158
            hcolor = 3
            draw 21 at PM * 19, 158
            return

lbl_1762:

            xdraw 23 at PM * 19 + 19, 136
            P1 = 40
            P2 = 40
            P3 = 30
            P4 = 20
            D1 = 10
            D2 = 30
            D3 = 50
            D4 = 250
            gosub sub_7570
            xdraw 23 at PM * 19 + 19, 136
            if SQ < 1000 then
                SQ = SQ - 104
                goto lbl_1815
            end if
            TM = int(SQ / 1000)
            WG = SQ - 1000 * TM
            print character_names(WG) " IS HEALED"
            DM = int(rnd(1) * (4 + 6 * TM * TM))
            if fn W(12) - fn W(13) < DM then
                DM = fn W(12) - fn W(13)
            end if
            poke fn O(13), fn W(13) + DM
            SQ = TM
            goto lbl_1831

lbl_1815:

            if SQ > 25 then
                goto lbl_1830
            end if
            on SQ gosub sub_2010, sub_2020, sub_2030, sub_2040, sub_2080, sub_2090, sub_2100, sub_2110, sub_2130, sub_2140, sub_2150, sub_2160, sub_2180, sub_2190, sub_2200, sub_2210, sub_2290, sub_2300, sub_2310, sub_2320, sub_2340, sub_2350, sub_2360, sub_2370, sub_2390
            goto lbl_1831

lbl_1830:

            on SQ - 25 gosub sub_2400, sub_2410, sub_2420, sub_2440, sub_2450, sub_2460, sub_2470, sub_2610, sub_2620, sub_2630, sub_2640, sub_2700, sub_2890, sub_2780, sub_2820, sub_2750, sub_2800, sub_2730, sub_2860, sub_2900, sub_2760, sub_2770

lbl_1831:

            for PS = 1 to PA
            next
            HP = get_character_data(11) - SQ + 4 * int((SQ - 1) / 3.95)
            poke character_data_address(60), 1
            poke character_data_address(11), HP * (HP > 0)

lbl_1835:

            IN%(PM) = 4

lbl_1840:

            print
            SP = 0
        next PM
        for X = 0 to MG
            scale = C%(X)
            for Y = 0 to GN%(X)
                home
                if ST%(X, Y) = 3 then
                    goto lbl_1885
                end if
                if ST%(X, Y) <> 1 or rnd(1) > .15 then
                    goto lbl_1950
                end if
                print N$(X) " AWAKENS"
                for PS = 1 to PA
                next
                ST%(X, Y) = 2
                goto lbl_1950

lbl_1885:

                if 3 * LV + 5 * SR * SR < rnd(1) * 100 then
                    goto lbl_1950
                end if
                WG = 0
                if rnd(1) * 100 < SL%(X) * (2 + 2 * RN%(X)) / (2 + MG) then
                    goto lbl_1940
                end if
                if RN%(2) = X and YS%(X) < 40 then
                    goto lbl_1950
                end if

lbl_1892:

                TM = int(AK%(X) / 82)
                if TM < 1 then
                    TM = 1
                end if
                ML = 1
                gosub sub_2006

lbl_1897:

                PM = P%((Y + rnd(1)) / (GN%(X) + 1) * (PL + 1))
                if rnd(1) * 100 < AK%(X) / TM - get_character_data(CHARACTER_ADROITNESS) or get_character_data(CHARACTER_STATUS) = CHARACTER_STATUS_SLEEP then
                    goto lbl_1920
                end if
                print N$(X) " MISSES"
                P1 = 1
                P2 = 1
                P3 = 1
                P4 = 3
                D1 = 1
                D2 = 1
                D3 = 1
                D4 = 100
                gosub sub_7570
                for PS = 1 to PA
                next
                goto lbl_1930

lbl_1920:
    
                DM = int(rnd(1) ^ .5 * DM%(X))
                print N$(X) " HITS"
                DM = DM - get_character_data(56)
                if IN%(PM) = 3 and DM > 0 then
                    DM = DM - get_character_data(163)
                    IN%(PM) = 4
                end if
                gosub do_character_damage
                if WG = 100 then
                    goto lbl_1934
                end if
                if WG = 101 then
                    goto lbl_1937
                end if

lbl_1930:

                ML = ML + 1
                if ML > TM then
                    goto lbl_1950
                end if
                goto lbl_1897

lbl_1934:

                print "A STUNNING BLOW "
                poke character_data_address(18), 2
                IN%(PM) = 4
                for PS = 1 to PA
                next
                goto lbl_1950

lbl_1937:

                print "MAGIC IS DRAINED"
                poke character_data_address(11), .5 + get_character_data(11) * .6
                for PS = 1 to PA
                next
                goto lbl_1950
    
lbl_1940:

                WG = SP%(X, int(rnd(1) * 3))
                gosub sub_2006
                if WG < 34 then
                    print N$(X) " CASTS A SPELL "
                end if
                on WG gosub sub_3000, sub_3010, sub_3020, sub_3030, sub_3060, sub_3060, sub_3060, sub_3060, sub_3050, sub_3050, sub_3050, sub_3050, sub_3070, sub_3070, sub_3070, sub_3070, sub_3080, sub_3080, sub_3080, sub_3080, sub_3090, sub_3090, sub_3090, sub_3090, sub_3100, sub_3100, sub_3100, sub_3100, sub_3110, sub_3110, sub_3110, sub_3110, sub_3120, sub_3210, sub_3220, sub_3230, sub_3240
                if WG > 33 then
                    goto lbl_1892
                end if
                for PS = 1 to PA
                next

lbl_1950:

                print
            next Y
        next X
    next SR
    goto lbl_1000

sub_2006:

    ST%(X, Y) = 2
    hcolor = 0
    draw S%(X) at X%(X, Y), Y%(X)
    hcolor = H%(X)
    draw S%(X) + 1 at X%(X, Y), Y%(X)
    return

sub_2010:

    DM = 9
    goto lbl_2050

sub_2020:

    DM = 28
    goto lbl_2050

sub_2030:

    DM = 58
    goto lbl_2050

sub_2040:

    DM = 100

lbl_2050:

    WG = RN%(0)
    SP = 1
    DM = 1 + DM * rnd(1) * get_character_data(2) / 15
    if GN%(RN%(1)) > -1 then
        WG = RN%(1)
    end if
    if GN%(RN%(2)) > -1 then
        WG = RN%(2)
    end if
    for Z = 1 to sqr(DM)
        poke -16299, 0
        X = peek(-16336 - NS)
        poke -16300, 0
    next
    for K = 1 to 5
        MN = rnd(1) * (GN%(WG) + 1)
        if HP%(WG, MN) >= 1 then
            K = 5
        end if
    next K
    gosub sub_4100
    return

sub_2080:

    DM = 10
    goto lbl_2120

sub_2090:

    DM = 25
    goto lbl_2120

sub_2100:

    DM = 45
    goto lbl_2120

sub_2110:

    DM = 70

lbl_2120:

    TM = 58
    goto lbl_2230

sub_2130:

    DM = 2
    goto lbl_2170

sub_2140:

    DM = 4
    goto lbl_2170

sub_2150:

    DM = 7
    goto lbl_2170

sub_2160:

    DM = 11

lbl_2170:

    TM = 57
    goto lbl_2230

sub_2180:

    DM = 1
    goto lbl_2220

sub_2190:

    DM = 3
    goto lbl_2220

sub_2200:

    DM = 6
    goto lbl_2220

sub_2210:

    DM = 10

lbl_2220:

    TM = 56

lbl_2230:

    IN = DM
    for WG = 0 to cur_characters
        if TM = 58 then
            DM = IN + fn W(20)
        end if
        if TM = 57 then
            DM = IN + fn W(CHARACTER_SKILL_WEAPON) + fn W(162)
        end if
        if TM = 56 then
            DM = IN + fn W(164)
        end if
        if DM > 255 then
            DM = 255
        end if
        poke fn O(TM), DM
    next
    return

sub_2290:

    DM = .8
    goto lbl_2330

sub_2300:

    DM = .6
    goto lbl_2330

sub_2310:

    DM = .4
    goto lbl_2330

sub_2320:

    DM = .2

lbl_2330:

    TM = 1
    goto lbl_2500

sub_2340:

    DM = .8
    goto lbl_2380

sub_2350:

    DM = .6
    goto lbl_2380

sub_2360:

    DM = .4
    goto lbl_2380

sub_2370:

    DM = .2

lbl_2380:

    TM = 2
    goto lbl_2500

sub_2390:

    DM = .85
    goto lbl_2430

sub_2400:

    DM = .70
    goto lbl_2430

sub_2410:

    DM = .55
    goto lbl_2430

sub_2420:

    DM = .45

lbl_2430:

    TM = 3
    goto lbl_2500

sub_2440:

    DM = 5
    goto lbl_2480

sub_2450:

    DM = 11
    goto lbl_2480

sub_2460:

    DM = 41
    goto lbl_2480

sub_2470:

    DM = 81

lbl_2480:

    TM = 4

lbl_2500:

    IN = DM
    for Q = 0 to MG
        WG = RN%(Q)
        if (get_character_data(10) - PW%(WG)) * 5 + 50 < rnd(1) * 100 then
            goto lbl_2540
        end if
        if TM = 1 then
            SL%(WG) = SL%(WG) * DM
        end if
        if TM = 2 then
            D%(WG) = D%(WG) * DM
        end if
        if TM = 3 then
            AK%(WG) = AK%(WG) * DM
        end if

lbl_2540:

        if TM < 4 then
            goto lbl_2600
        end if
        if TM = 4 and (EX(WG) < 2000) and (int(EX(WG) / 7) = (EX(WG) / 7)) then
            goto lbl_2600
        end if
        for MN = 0 to GN%(WG)
            DM = rnd(1) * IN
            if TM = 4 then
                goto lbl_2570
            end if
            if TM = 5 then
                goto lbl_2560
            end if
            if rnd(1) * 100 < LV * LV then
                goto lbl_2590
            end if
            print N$(WG) " IS SLEPT"
            ST%(WG, MN) = sgn(ST%(WG, MN))
            for PS = 1 to PA
            next
            goto lbl_2590

lbl_2560:

            DM = DM - MA%(WG)
            goto lbl_2580

lbl_2570:

            if (get_character_data(10) - PW%(WG)) * 5 + 50 < rnd(1) * 100 then
                goto lbl_2590
            end if

lbl_2580:

            SP = 1
            gosub sub_4100

lbl_2590:

        next MN

lbl_2600:

    next Q
    return

sub_2610:

    DM = 7
    goto lbl_2650

sub_2620:

    DM = 15
    goto lbl_2650

sub_2630:

    DM = 31
    goto lbl_2650

sub_2640:

    DM = 66

lbl_2650:

    TM = 5
    goto lbl_2500

sub_2700:

    if rnd(1) * get_character_data(54) < rnd(1) * LV then
        goto lbl_2720
    end if
    print "MONSTERS CHARMED"
    NF = NF + 15
    CA = 0

lbl_2720:

    return

sub_2730:

    if 110 - 10 * LV < 100 * rnd(1) then
        return
    end if

lbl_2740:

    print "MONSTERS START DISSOLVING"
    MP = 2
    AK = 1
    EX = EX + EX(0) * GN%(0)
    return

sub_2750:

    poke character_data_address(58), 255
    poke character_data_address(57), 25
    poke character_data_address(56), 10
    return

sub_2760:

    poke character_data_address(58), 200
    poke character_data_address(57), 20
    poke character_data_address(56), 8
    return

sub_2770:

    for WG = 0 to cur_characters
        poke fn O(18),(fn W(18) > 0)
    next WG
    print "PARTY AWAKENS"
    return

sub_2780:

    if rnd(1) * 100 < 50 + 3 * get_character_data(54) then
        MP = 1
    end if
    return

sub_2800:

    if rnd(1) * 100 > 50 + 5 * (get_character_data(54) - LV) then
        return
    end if
    LV = LV - 6
    return

sub_2820:

    for WG = 0 to cur_characters
        if (fn W(18) > 0) or (fn W(4) < 1) then
            goto lbl_2850
        end if
        if rnd(1) * 100 > 50 + 5 * (get_character_data(54) - fn W(54)) then
            goto lbl_2850
        end if
        print character_names(WG) " IS ALIVE"
        poke fn O(18), 1
        poke fn O(13), fn W(12)
        WG = cur_characters

lbl_2850:

    next WG
    return

sub_2860:

    if cur_characters <> 5 then
        return
    end if
    cur_characters = 6
    PL = PL + 1
    P%(PL) = cur_characters
    return

sub_2890:

    TM = 6
    goto lbl_2500

sub_2900:

    if DA = 1 or EX(0) / 7 <> int(EX(0) / 7) then
        goto lbl_2950
    end if
    DA = 1
    HP = 5 * (get_character_data(54) - LV) - rnd(1) * 100
    if HP > -5 then
        goto lbl_2740
    end if
    if HP > -45 then
        print "MONSTERS RUN"
        MP = 2
    end if

lbl_2950:

    return

sub_3000:

    DM = rnd(1) * 12
    goto lbl_3040

sub_3010:

    DM = rnd(1) * 35
    goto lbl_3040

sub_3020:

    DM = rnd(1) * 70
    goto lbl_3040

sub_3030:

    DM = rnd(1) * 120

lbl_3040:

    PM = P%(int(rnd(1) * (PL + 1)))
    gosub do_character_damage
    return

sub_3050:

    DM%(X) = 8 + 2 ^ (WG - 8) * 1.5
    return

sub_3060:

    AK%(X) = 35 + 30 * 2 ^ (WG - 5)
    return

sub_3070:

    MA%(X) = 4 + 4 * (WG - 12)
    return

sub_3080:

    DM = 1 - .2 * (WG - 16)
    TM = 57
    print "THE PARTY'S ARMOR IS REDUCED"
    goto lbl_3130

sub_3090:

    DM = 1 - .2 * (WG - 20)
    TM = 58
    print "THE PARTY IS SLOWED"
    goto lbl_3130

sub_3100:

    DM = 10 * 2 ^ (WG - 25) + 6
    TM = 1
    goto lbl_3130

sub_3110:

    DM = 8 * 2 ^ (WG - 29) + 4
    TM = 2
    goto lbl_3130

sub_3120:

    TM = 18

lbl_3130:

    IN = DM
    for PM = 0 to cur_characters
        DM = rnd(1) * IN
        if TM = 2 then
            goto lbl_3180
        end if
        if (PW%(X) - get_character_data(10)) * 5 + 50 < rnd(1) * 100 then
            goto lbl_3200
        end if
        if TM = 18 then
            goto lbl_3170
        end if
        if TM = 1 then
            goto lbl_3190
        end if
        poke character_data_address(TM), get_character_data(TM) * DM + .5
        goto lbl_3200

lbl_3170:

        print character_names(PM) " IS SLEPT"
        poke character_data_address(TM), 2 * sgn(get_character_data(TM))
        IN%(PM) = 4
        for PS = 1 to PA
        next PS
        goto lbl_3200

lbl_3180:

        DM = DM - get_character_data(56)

lbl_3190:

        gosub do_character_damage

lbl_3200:

    next PM
    return

sub_3210:

    WG = 100
    return

sub_3220:

    WG = 101
    return

sub_3230:

    DM = 20
    goto lbl_3250

sub_3240:

    DM = 36

lbl_3250:

    print N$(X) " BREATHES"
    TM = 2
    goto lbl_3130

' -----------------------------------------------------
do_character_damage:

    DM = int(DM - 1) * (DM > 1) + 1
    if get_character_data(CHARACTER_STATUS) = CHARACTER_STATUS_DEAD then
        return
    end if
    P4 = 1
    P1 = 250
    P2 = 1
    P3 = 1
    D4 = 1
    D1 = 5
    D2 = 1
    D3 = 1
    gosub sub_7570
    print character_names(PM) " TAKES " int(DM) " DAMAGE "
    if get_character_data(13) <= DM then
        goto lbl_4020
    end if
    poke character_data_address(13), get_character_data(13) - DM
    goto lbl_4030

lbl_4020:

    print character_names(PM) " DIES"
    poke character_data_address(13), 0
    IN%(PM) = 4
    poke character_data_address(18), 0
    poke character_data_address(4), get_character_data(4) - sgn(get_character_data(4)) - (get_character_data(4) > 1) * (get_character_data(6) < 11)
    for PS = 1 to PA
    next
    P1 = 175
    P2 = 175
    P3 = 175
    P4 = 220
    D1 = 85
    D2 = 85
    D3 = 85
    D4 = 250
    gosub sub_7570
    AL = 0
    for WG = 0 to cur_characters
        AL = AL + fn W(18)
    next
    if AL = 0 then
        goto go_cemetary
    end if

lbl_4030:

    for PS = 1 to PA
    next PS
    print
    return

sub_4100:

    CA = 1
    if DM < 1 then
        DM = 1
    end if
    if MN < 0 then
        goto lbl_4160
    end if
    if HP%(WG, MN) < 1 then
        goto lbl_4160
    end if
    print N$(WG) " TAKES " int(DM) " DAMAGE "
    P4 = 1
    P1 = 250
    P2 = 1
    P3 = 1
    D4 = 1
    D1 = 5
    D2 = 1
    D3 = 1
    gosub sub_7570
    HP%(WG, MN) = HP%(WG, MN) - DM
    if SP = 0 then
        goto lbl_4135
    end if
    D = SP * 35 - 11
    SP = 0
    scale = C%(WG)
    hcolor = 3
    xdraw D at X%(WG, MN), Y%(WG)
    for PS = 1 to 500
    next
    xdraw D at X%(WG, MN), Y%(WG)

lbl_4135:

    if HP%(WG, MN) > 0 then
        goto lbl_4150
    end if
    print N$(WG) " DIES"
    HP%(WG, MN) = 0
    ST%(WG, MN) = 2
    EX = EX + EX(WG)
    hcolor = 0
    scale = C%(WG)
    draw S%(WG) at X%(WG, MN), Y%(WG)
    draw S%(WG) + 1 at X%(WG, MN), Y%(WG)

lbl_4150:

    for PS = 1 to PA
    next PS
    print

lbl_4160:

    return

' -----------------------------------------------------
init_temp_characters_values:

    for PM = 0 to cur_characters
        poke character_data_address(CHARACTER_TEMP_ARMOR_POINT_VALUE), get_character_data(CHARACTER_ARMOR_POINT_VALUE)
        poke character_data_address(CHARACTER_TEMP_WEAPON_POINT_VALUE), get_character_data(CHARACTER_SKILL_WEAPON) + get_character_data(CHARACTER_WEAPON_POINT_VALUE)
        poke character_data_address(CHARACTER_TEMP_SKILL_ATTACK), get_character_data(CHARACTER_SKILL_ATTACK)
        WG = 2 * get_character_data(CHARACTER_DEXTERITY) - 5 * get_character_data(CHARACTER_ARMOR_POINT_VALUE) + get_character_data(CHARACTER_SKILL_PARRY) / 4
        poke character_data_address(CHARACTER_STATUS), (get_character_data(CHARACTER_STATUS) > CHARACTER_STATUS_DEAD)
        poke character_data_address(CHARACTER_ADROITNESS), WG * (WG > 0) + get_character_data(CHARACTER_SHIELD_POINT_VALUE) / 3
    next PM
    return

' -----------------------------------------------------
go_cemetary:

    &run "CEMETARY"

lbl_4220:

    CX = OX
    CY = OY

lbl_4240:

    YS = 1
    GL = 0
    goto lbl_4260

lbl_4250:

    MS = 1

lbl_4260:

    for PS = 1 to 2000
    next
    text
    home
    if AK = 1 then
        print "MONSTERS KILLED"
    end if
    PM = 6
    poke character_data_address(18), 0
    gosub sub_1525
    cur_characters = peek(SA + CHARACTERS_IN_PARTY)
    gosub init_temp_characters_values
    print "EACH SURVIVOR GETS " int(EX / (PL + 1)) " XP AND " int(GL / (PL + 1)) " GOLD"
    for PS = 1 to 3000
    next
    EX = EX / 10
    FE = FE - (YS = 0)
    if FE < 6 then
        FE = 1
    end if
    GL = GL + peek(SA + 1200) + 256 * peek(SA + 1199)
    EX = EX + peek(SA + 1198) + 256 * peek(SA + 1197)
    Q = 65535
    if GL > Q then
        GL = Q
    end if
    if EX > Q then
        EX = Q
    end if
    poke SA + 1199, GL / 256
    poke SA + 1197, EX / 256
    poke SA + 1198, EX - 256 * peek(SA + 1197)
    poke(SA + 1200), GL - 256 * peek(SA + 1199)
    if YS = 1 then
        goto command_prompt
    end if
    WG = peek(get_dungeon_tile_address(0))
    if WG > 184 and WG < 200 then
        poke get_dungeon_tile_address(0), 185
    end if
    if WG > 127 and WG < 138 then
        poke get_dungeon_tile_address(0), 138
    end if
    if WG > 199 and WG < 215 then
        poke get_dungeon_tile_address(0), 200
    end if
    if MQ = 0 or GN%(0) >= 0 then
        goto lbl_4300
    end if
    print
    print "YOU HAVE KILLED ONE OF PLUTO'S MINIONS"
    print character_names(P%(0)) " TAKES AN AMULET"
    for PS = 1 to 11111
    next
    IT = 140 + MQ
    gosub sub_4390
    for PM = 0 to cur_characters
        poke character_data_address(CHARACTER_AMULETS), get_character_data(CHARACTER_AMULETS) + 2 ^ (MQ - 1)
    next

lbl_4300:

    ' Check if it's pluto that we just killed
    if MO <> 79 then
        goto lbl_4310
    end if
    ' Load it at 0x400 but where is it used ?
    &recall "SCROLLL0"

' Wait for return key
lbl_4306:

    poke 0xC010, 0
    get A$
    if asc(A$) <> 13 then
        goto lbl_4306
    end if

lbl_4310:

    if rnd(1) * 100 > LV * 2 + 45 * MS + 50 then
        goto command_prompt
    end if
    if IA = 0 and IB = 0 then
        goto command_prompt
    end if
    if MS = 1 then
        goto lbl_4330
    end if
    print
    PH = 0
    for PM = 0 to cur_characters
        if get_character_data(18) = 0 then
            goto lbl_4326
        end if
        if rnd(1) * 100 > get_character_data(24) then
            goto lbl_4326
        end if
        PH = 1
        print character_names(PM) " SPOTS AN ITEM"

lbl_4326:

    next PM
    if PH = 0 then
        goto lbl_4350
    end if

lbl_4330:

    print
    IT = int(IA + 3 - rnd(1) * 5)
    gosub sub_4370
    IT = int(IB + 3 - rnd(1) * 5)
    gosub sub_4370

lbl_4350:

    for PS = 1 to 2000
    next
    goto command_prompt

sub_4370:

    if IT < 1 or IT > 255 then
        return
    end if
    print
    print "YOU FIND " monsters_items_list((IT - 1) / 20) ". KEEP IT?" ;

wait_keys_Y_N:

    get A$
    poke -16368, 0
    if A$ = "N" then
        return
    end if
    if A$ <> "Y" then
        goto wait_keys_Y_N
    end if

sub_4390:

    PH = 0
    for X = SA + 1210 to SA + 1269
        if peek(X) = 0 then
            PH = X
        end if
    next
    if PH = 0 then
        return
    end if
    poke PH, IT
    return

' -----------------------------------------------------
enter_dungeon:

    gosub sub_1525
    CX = peek(SA + 1192)
    CY = peek(SA + 1193)
    OX = CX
    OY = CY

display_from_old_position:

    gosub display_prompt_menu

lbl_5010:

    gosub sub_5020
    goto handle_current_tile_event

sub_5020:

    ' Draw tile at party position ?
    WG = peek(LA + CY * 33 + CX)
    ' don't draw if it's a wall or a door
    if WG < 2 or (WG > 184 and WG < 215) then
        return
    end if

display_dungeon_tiles:

    for X = CX - (CX > 0) to CX + (CX < 32)
        for Y = CY - (CY > 0) to CY + (CY < 37)
            WG = get_dungeon_tile_data(0)
            J = 144 + 4 * X
            IA = 4 + 4 * Y
            if get_dungeon_tile_data(0) < 2 then
                ' draw wall
                hcolor = 3
                draw 31 at J, IA
                goto done_drawing_tile
            end if
            hcolor = 0
            draw 31 at J, IA
            if WG < 185 then
                ' walkable
                goto done_drawing_tile
            end if
            ' draw stairs etc.
            hcolor = 3 * (WG < 215 or WG > 217)
            draw 32 + (WG > 199) + (WG > 214) + (WG > 217) + (WG > 220) at J, IA

done_drawing_tile:

        next Y
    next X
    return

handle_current_tile_event:

    X = CX
    Y = CY
    WG = get_dungeon_tile_data(0)
    if WG > 7 and WG < 18 then
        goto tile_possible_random_encounter
    end if
    if WG > 138 and WG < 185 then
        goto tile_walkable
    end if
    if WG > 220 then
        goto tile_run_script
    end if
    if WG > 217 then
        goto tile_stairs
    end if
    if WG > 214 then
        goto ask_exit_dungeon
    end if
    if WG > 184 then
        goto tile_door
    end if
    if WG > 1 and WG < 7 then
        goto tile_trap
    end if
    if WG > 17 and WG < 128 then
        goto tile_special_message
    end if
    if WG > 8 and WG < 138 then
        goto tile_random_encounter
    end if
    goto display_prompt_command

' -----------------------------------------------------
command_prompt:

    gosub display_prompt_menu

display_prompt_command:

    poke 34, 23
    poke -16304, 0
    home
    print "COMMAND:" ;
    xdraw 30 at 144 + 4 * CX, 4 + 4 * CY
    get A$
    xdraw 30 at 144 + 4 * CX, 4 + 4 * CY
    vtab 1
    poke 34, 0
    if A$ = "3" then
        goto lbl_5220
    end if
    CM = asc(A$)
    if CM < 65 or CM > 90 then
        goto command_prompt
    end if
    on CM - 64 goto command_prompt,
                    command_prompt,
                    ask_cast_spell,
                    command_prompt,
                    lbl_5240,
                    command_prompt,
                    command_prompt,
                    display_party_health,
                    lbl_7400,
                    command_prompt,
                    command_prompt,
                    lbl_5400,
                    command_prompt,
                    lbl_5220,
                    command_prompt,
                    command_prompt,
                    command_prompt,
                    command_prompt,
                    lbl_5230,
                    lbl_7550,
                    ask_use_potion,
                    command_prompt,
                    lbl_5250
    goto command_prompt

lbl_5220:

    DN = 1
    DE = 0
    goto lbl_5260

lbl_5230:

    DN = -1
    DE = 0
    goto lbl_5260

lbl_5240:

    DN = 0
    DE = 1
    goto lbl_5260

lbl_5250:

    DN = 0
    DE = -1

lbl_5260:

    X = CX + DE
    Y = CY - DN
    if get_dungeon_tile_data(0) > 0 then
        goto lbl_5290
    end if

' -----------------------------------------------------
' Can't go beyond them
dungeon_boundaries:

    home
    vtab 23
    print "THAT IS A WALL"
    for PS = 1 to 700
    next
    goto command_prompt

lbl_5290:

    if X < 0 or X > 32 or Y < 0 or Y > 37 then
        goto dungeon_boundaries
    end if
    OX = CX
    OY = CY
    CX = X
    CY = Y
    goto lbl_5010

lbl_5400:

    IT = CX
    PS = CY
    if WG < 2 or (WG > 184 and WG < 215) then
        goto command_prompt
    end if
    Z = fre(0)
    for DN = -1 to 1
        for DE = -1 to 1
            for Q = 1 to 3
                J = Q
                CX = IT + DE * J
                if CX < 0 or CX > 32 then
                    Q = 3
                    goto lbl_5450
                end if
                CY = PS + DN * J
                if CY < 0 or CY > 37 then
                    Q = 3
                    goto lbl_5450
                end if
                IB = peek(LA + CY * 33 + CX)
                if IB < 2 or IB > 184 then
                    Q = 3
                    goto lbl_5450
                end if
                J = 4

lbl_5450:

            next
            if J = 1 then
                goto lbl_5480
            end if
            J = J - 1
            CX = IT + DE * J
            CY = PS + DN * J
            gosub display_dungeon_tiles

lbl_5480:

        next DE
    next
    CX = IT
    CY = PS
    goto command_prompt

' -----------------------------------------------------
tile_special_message:

    home
    vtab 24
    M1 = WG - 17
    gosub display_special_message

wait_key_after_message:

    get A$
    if asc(A$) <> 13 then
        goto wait_key_after_message
    end if
    goto command_prompt

' -----------------------------------------------------
tile_random_encounter:

    MO = peek(3178 + WG)
    home
    vtab 24
    SU = 1
    SM = 1
    goto start_encounter_system

' -----------------------------------------------------
tile_trap:

    TR = WG - 1
    PH = -1
    for PM = 0 to cur_characters
        if get_character_data(CHARACTER_STATUS) = CHARACTER_STATUS_DEAD or rnd(1) * 100 > get_character_data(CHARACTER_SKILL_SPOT_TRAP) then
            goto lbl_6230
        end if
        PH = PM

lbl_6230:

    next
    if PH < 0 then
        goto handle_trap_damages
    end if
    home
    vtab 21
    print character_names(PH) " SPOTS A TRAP"
    print "D)ISARM OR L)EAVE" ;

lbl_6250:

    get A$
    if A$ = "L" then
        CX = OX
        CY = OY
        goto display_from_old_position
    end if
    if A$ <> "D" then
        goto lbl_6250
    end if
    print
    print "WHO WILL DISARM " ;

lbl_6280:

    get A$
    PM = val(A$) - 1
    if PM < 0 or PM > cur_characters or get_character_data(18) = 0 then
        goto lbl_6280
    end if
    print A$
    if rnd(1) * 100 > get_character_data(28) then
        print character_names(PM) " FAILS" ;
        for PS = 1 to 3000
        next
        goto handle_trap_damages
    end if
    print character_names(PM) " SUCCEEDS" ;
    poke get_dungeon_tile_address(0), 7
    for PS = 1 to 3000
    next
    goto command_prompt

handle_trap_damages:

    M1 = TR + 5
    text
    home
    gosub display_special_message
    print
    print
    for PM = 0 to cur_characters
        if get_character_data(CHARACTER_STATUS) = CHARACTER_STATUS_OKAY and rnd(1) * 100 < get_character_data(CHARACTER_ADROITNESS) - TR * 3 then
            goto lbl_6420
        end if
        DM = rnd(1) * 5 * TR
        gosub do_character_damage
        goto lbl_6430

lbl_6420:

        print character_names(PM) " AVOIDS THE TRAP"

lbl_6430:

    next
    poke get_dungeon_tile_address(0), 7
    goto wait_key_after_message

' -----------------------------------------------------
ask_use_potion:

    text
    home
    print "WHO WILL USE POTION" ;
    get A$
    PM = val(A$) - 1
    if PM < 0 or PM > cur_characters then
        goto command_prompt
    end if
    text
    home
    print tab(7) character_names(PM)
    print S$
    J = 0
    for X = 152 to 160
        Y = get_character_data(X)

        if Y < 101 or Y > 120 then
            goto lbl_6745
        end if
        print X - 151 "    " ;
        J = J + 1
        if Y < 111 then
            print "HEALING POTION " Y - 100
            goto lbl_6745
        end if
        print "MAGIC POTION " Y - 110

lbl_6745:

    next
    if J = 0 then
        print "YOU HAVE NO POTIONS"
        print
        print S$
        for PS = 1 to 3000
        next
        goto command_prompt
    end if
    print
    print S$
    print
    print "USE WHICH POTION " ;
    get A$
    IT = val(A$)
    if IT = 0 then
        goto command_prompt
    end if
    IM = get_character_data(IT + 151)
    if IM < 101 or IM > 120 then
        goto command_prompt
    end if
    print A$
    print "ON WHOM " ;

lbl_6780:

    get A$
    WG = val(A$) - 1
    if WG < 0 or WG > cur_characters then
        goto lbl_6780
    end if
    poke character_data_address(IT + 151), 0
    print A$
    if IM < 111 then
        goto lbl_6830
    end if
    DM = IM * 3 - 330 + fn W(11)
    if DM > fn W(10) then
        DM = fn W(10)
    end if
    print character_names(WG) " RECEIVES MAGIC"
    poke fn O(11), DM
    goto lbl_6850

lbl_6830:

    DM = (IM - 100) ^ 2 + fn W(13)
    if DM > fn W(12) then
        DM = fn W(12)
    end if

lbl_6840:

    print character_names(WG) " IS HEALED"
    poke fn O(13), DM

lbl_6850:

    for PS = 1 to 2000
    next
    goto command_prompt

' -----------------------------------------------------
ask_cast_spell:

    text
    home
    print "WHO WILL CAST SPELL " ;
    get A$
    PM = val(A$) - 1
    if PM < 0 or PM > cur_characters then
        goto command_prompt
    end if
    print A$
    print
    if get_character_data(18) = 0 then
        goto command_prompt
    end if
    input "WHICH SPELL ?" ; WS
    if WS < 1 or WS > 60 then
        goto command_prompt
    end if
    if get_character_data(WS + 60) <> 1 then
        goto ask_cast_spell
    end if
    DM = WS - 4 * int((WS - 1) / 3.95)
    if get_character_data(11) < DM then
        goto ask_cast_spell
    end if
    poke character_data_address(11), get_character_data(11) - DM
    if WS = 44 then
        gosub sub_2820
        gosub sub_1525
    end if
    if WS < 5 then
        goto lbl_7010
    end if
    if WS = 52 then
        print "MONSTERS ARE LEVEL " 2 * VL + 2
        goto lbl_6850
    end if
    ' Divine II
    if WS = 57 then
        print "THAT SPELL WILL NOT WORK ON THIS PLANE"
    end if
    ' Divine I
    if WS > 57 then
        print
        print gods_list(rnd(1) * rnd(1) * 4) " APPEARS AND GIVES YOU ADVICE:"
        print
        print
        M1 = 105
        gosub display_special_message
        goto wait_key_after_message
    end if
    goto lbl_6850

lbl_7010:

    print
    print "ON WHOM " ;

lbl_7015:

    get A$
    WG = val(A$) - 1
    if WG < 0 or WG > cur_characters then
        goto lbl_7015
    end if
    print A$
    DM = int(rnd(1) * (4 + 6 * WS * WS)) + fn W(13)
    if DM > fn W(12) then
        DM = fn W(12)
    end if
    goto lbl_6840

' -----------------------------------------------------
ask_exit_dungeon:

    home
    vtab 24
    print "AN EXIT. TAKE IT?" ;
    get A$
    if A$ = "N" then
        goto command_prompt
    end if
    if A$ <> "Y" then
        goto ask_exit_dungeon
    end if
    ' Store the number of this dungeon
    poke CURRENT_DUNGEON, peek(SA + 1191)
    ' Store the exit taken
    ' 645 648 651
    ' (OUTTx, X, Y)
    for X = 0 to 2
        poke SA + 1191 + X, peek(2050 + 621 + X + 3 * WG)
    next

    &run "DNGOUT"

lbl_7400:

    text
    home
    print "DAY OUT: " peek(SA + 1194)
    print "EXPERIENCE POINTS EARNED: " 10 * (256 * peek(SA + 1197) + peek(1198 + SA))
    print "GOLD PIECES CARRIED: " 256 * peek(SA + 1199) + peek(SA + 1200)
    print "ITEMS ACQUIRED:"
    for X = 0 to 8
        I%(X) = 0
    next
    for X = SA + 1210 to SA + 1269
        J = int((peek(X) - 1) / 20)
        if J < 0 then
            goto lbl_7420
        end if
        I%(J) = I%(J) + 1

lbl_7420:

    next
    for X = 0 to 8
        if I%(X) = 0 then
            goto lbl_7430
        end if
        print tab(10) monsters_items_list(X) "S: " I%(X)

lbl_7430:

    next
    vtab 23
    get A$
    for PM = 0 to cur_characters
        home
        print "#" PM + 1 " " character_names(PM) " LEVEL " get_character_data(CHARACTER_LEVEL) " " S$(get_character_data(CHARACTER_STATUS))
        print
        print "HIT POINTS " get_character_data(CHARACTER_CURRENT_HIT_POINTS) "/" get_character_data(CHARACTER_MAX_HIT_POINTS) tab(20) "MAGIC " get_character_data(CHARACTER_CURRENT_MAGIC) "/" get_character_data(CHARACTER_MAX_MAGIC)
        print
        print "SKILLS:  ATTACK " get_character_data(CHARACTER_SKILL_ATTACK) tab(23) "SPOT TRAP " get_character_data(CHARACTER_SKILL_SPOT_TRAP)
        print tab(11) "PARRY " get_character_data(CHARACTER_SKILL_PARRY) tab(21) "DISARM TRAP " get_character_data(CHARACTER_SKILL_DISARM_TRAP)
        print tab(7) "PICK LOCK " get_character_data(CHARACTER_SKILL_PICK_LOCK) tab(23) "FIND ITEM " get_character_data(CHARACTER_SKILL_FIND_ITEM)
        print tab(28) "TOSS " get_character_data(CHARACTER_SKILL_TOSS_ROCK)
        print "SPELLS:" ;
        for X = 1 to 60
            if get_character_data(X + 60) = 1 then
                print "  " X ;
            end if
        next
        print
        vtab 15
        print "POTIONS:"
        for X = 152 to 160
            J = get_character_data(X)
            if J > 100 and J < 111 then
                print tab(10) "HEALING " J - 100
            end if
            if J > 110 and J < 121 then
                print tab(10) "MAGIC " J - 110
            end if
        next
        vtab 23
        get A$
    next
    goto command_prompt

lbl_7550:

    home
    vtab 22
    print "TIME LAG " ;
    get A$
    X = val(A$)
    print X
    PA = 120 * X
    print
    print "SOUND? " ;
    get A$
    NS = (A$ = "N")
    poke SA + 1204, X
    poke SA + 1205, NS
    goto command_prompt

sub_7570:

    if NS = 1 then
        return
    end if
    poke 768, P1
    poke 769, D1
    call 770
    poke 768, P2
    poke 769, D2
    call 770
    poke 768, P3
    poke 769, D3
    call 770
    poke 768, P4
    poke 769, D4
    call 770
    return

' -----------------------------------------------------
tile_walkable:

    M7 = WG - 118
    if M7 = M1 then
        goto display_prompt_command
    end if
    goto command_prompt

' -----------------------------------------------------
tile_possible_random_encounter:

    if (rnd(1) * 100) > FE then
        ' no encounter
        goto lbl_7740
    end if
    home
    vtab 24
    SU = 1
    SM = 1
    MO = WG - 8 + int(rnd(1) * 3) + 12 * VL
    goto start_encounter_system

lbl_7740:

    M7 = WG + 3
    if M7 = M1 then
        goto display_prompt_command
    end if
    goto command_prompt

' -----------------------------------------------------
tile_stairs:

    home
    vtab 24
    print "STAIRS FROM LEVEL " WG - 217 " TO " WG - 216
    for PS = 1 to 2000
    next
    goto command_prompt

' -----------------------------------------------------
tile_door:

    home
    vtab 23

    DR = WG - 184
    ' J = 1 if the door is a vertical one
    J = DR > 15
    DR = DR - 15 * J

    if DR > 13 then
        goto locked_door
    end if
    ' Opened door
    if DR < 2 then
        goto command_prompt
    end if

    PH = -1
    for PM = 0 to cur_characters
        if get_character_data(CHARACTER_STATUS) = CHARACTER_STATUS_DEAD or rnd(1) * 100 > get_character_data(CHARACTER_SKILL_LISTEN) then
            goto lbl_7860
        end if
        PH = PM

lbl_7860:

    next
    if PH = -1 then
        goto lbl_7890
    end if
    print character_names(PH) " HEARS MONSTERS. GO BACK?" ;

lbl_7875:

    get A$
    if A$ = "Y" then
        goto restore_old_position_from_door
    end if
    if A$ <> "N" then
        goto lbl_7875
    end if

lbl_7890:

    MO = 12 * VL + DR - 2
    SM = 1
    SU = 1 - (rnd(1) > .5) * (PH > -1)
    goto start_encounter_system

restore_old_position_from_door:

    CX = OX
    CY = OY
    goto display_from_old_position

locked_door:

    if DR > 14 then
        goto unlockable_door
    end if
    PH = -1
    for PM = 0 to cur_characters
        if get_character_data(CHARACTER_STATUS) = CHARACTER_STATUS_DEAD or rnd(1) * 100 > get_character_data(CHARACTER_SKILL_PICK_LOCK) then
            goto lbl_7940
        end if
        PH = PM

lbl_7940:

    next
    ' No one is able to unlock it
    if PH = -1 then
        goto unlockable_door
    end if
    print character_names(PH) " PICKS THE LOCK"
    ' Store it as opened
    poke get_dungeon_tile_address(0), 185 + J * 15
    for PS = 1 to 2500
    next
    goto command_prompt

unlockable_door:

    print "NO ONE CAN PICK THE LOCK"
    ' Store it as unlockable
    ' NOTE: i don't think this should be done
    ' as it'll remain unlockable in the future
    poke get_dungeon_tile_address(0), 199 + J * 15
    for PS = 1 to 2500
    next
    goto restore_old_position_from_door

' -----------------------------------------------------
display_prompt_menu:

    home
    vtab 21
    gosub sub_8640
    vtab 22
    print "C)AST  H)EALTH  I)NSPECT      W)  3)  E)L)OOK   U)SE   T)IME LAG          S)"
    return

' -----------------------------------------------------
tile_run_script:

    LC = 2050 + 1270 + 5 * (WG - 220)
    X = peek(LC)
    if X = 255 then
        goto command_prompt
    end if
    text
    MO = 0
    home
    J = (X > 127)
    M1 = X - 128 * J
    gosub display_special_message
    if J = 1 then
        poke LC, 255
    end if
    J = peek(LC + 1)
    if J < 2 then
        X = 1
        goto lbl_8240
    end if

wait_key_script_message:

    get A$
    X = val(A$)
    if X < 1 or X > J then
        goto wait_key_script_message
    end if

lbl_8240:

    X = peek(LC + 1 + X)
    LC = 2050 + 1450 + 2 * X
    print
    print
    print

read_next_cmd:

    X = peek(LC)
    D = peek(LC + 1)
    D2 = peek(LC + 2)
    D3 = peek(LC + 3)

    J = (X > 127)
    X = X - 128 * J

    F = (X > 63)
    X = X - 64 * F
    if F = 1 then
        poke LC, J * 128
    end if

    ' I think it starts at 1
    on X goto script_cmd_damage_characters_from_smoke,
              script_cmd_damage_characters,
              script_cmd_damage_characters_from_spell,
              script_cmd_damage_characters,
              script_cmd_encounter,
              script_cmd_find_item,
              script_cmd_found_gold,
              script_cmd_add_gold,
              script_cmd_gold_stolen,
              script_cmd_rem_gold,
              script_cmd_print_message,
              script_cmd_warn_and_teleport,
              script_cmd_teleport,
              script_cmd_warn_and_modify_dungeon,
              script_cmd_modify_dungeon,
              script_cmd_hidden_trap,
              script_cmd_surprise_attack,
              script_cmd_change_characters_data,
              lbl_8460,
              script_cmd_goto,
              script_cmd_random_goto,
              script_cmd_change_tile_script,
              script_wait_return_key
    goto check_end_of_script_cmd

' -----------------------------------------------------
script_cmd_damage_characters_from_smoke:

    print "SMOKE FILLS THE AIR"
    goto script_cmd_damage_characters

' -----------------------------------------------------
script_cmd_damage_characters_from_spell:

    print "A SPELL IS CAST"

' -----------------------------------------------------
script_cmd_damage_characters:

    print
    for PM = 0 to cur_characters
        DM = rnd(1) * D * 10 / get_character_data(CHARACTER_LUCK)
        gosub do_character_damage
    next
    goto check_end_of_script_cmd

' -----------------------------------------------------
script_cmd_encounter:

    SM = 1
    SU = 1
    MO = D
    goto script_wait_return_key

' -----------------------------------------------------
script_cmd_find_item:

    IT = D
    gosub sub_4370
    goto check_end_of_script_cmd

' -----------------------------------------------------
script_cmd_found_gold:

    print "THE PARTY GETS SOME GOLD"

' -----------------------------------------------------
script_cmd_add_gold:

    X = peek(SA + 1199) + D
    poke SA + 1200, 255
    if X > 255 then
        X = 255
    end if
    poke SA + 1199, X
    goto check_end_of_script_cmd

' -----------------------------------------------------
script_cmd_gold_stolen:

    print "SOME OF YOUR GOLD IS TAKEN"

' -----------------------------------------------------
script_cmd_rem_gold:

    poke SA + 1200, 0
    X = peek(SA + 1199) - D
    poke SA + 1199, X * (X > 0)
    goto check_end_of_script_cmd

' -----------------------------------------------------
script_cmd_print_message:

    M1 = D
    gosub display_special_message
    goto check_end_of_script_cmd

' -----------------------------------------------------
script_cmd_warn_and_teleport:

    print "THE PARTY IS MOVED"

' -----------------------------------------------------
script_cmd_teleport:

    CX = D
    CY = D2
    OX = CX
    OY = CY
    LC = LC + 2
    goto check_end_of_script_cmd

' -----------------------------------------------------
script_cmd_warn_and_modify_dungeon:

    print "YOU HEAR A NOISE IN THE DISTANCE"

' -----------------------------------------------------
script_cmd_modify_dungeon:

    LC = LC + 2
    poke LA + 33 * D2 + D, D3
    goto check_end_of_script_cmd

' -----------------------------------------------------
script_cmd_hidden_trap:

    TR = D
    goto handle_trap_damages

' -----------------------------------------------------
script_cmd_surprise_attack:

    print "MONSTERS APPEAR"
    SM = 0
    SU = 1
    MO = D
    goto script_wait_return_key

' -----------------------------------------------------
script_cmd_change_characters_data:

    LC = LC + 2
    for PM = 0 to cur_characters
        if get_character_data(CHARACTER_STATUS) > CHARACTER_STATUS_DEAD then
            poke character_data_address(D), D2
        end if
    next
    goto check_end_of_script_cmd

lbl_8460:

    LC = LC + 2
    Q = 0
    for PM = 0 to cur_characters
        Q = Q + (get_character_data(D) >= D2)
    next
    if Q > 0 then
        goto check_end_of_script_cmd
    end if
    CX = OX
    CY = OY
    LC = 2050 + 1448 + 2 * D3
    goto check_end_of_script_cmd

' -----------------------------------------------------
script_cmd_goto:

    LC = 2050 + 1448 + 2 * D
    goto check_end_of_script_cmd

' -----------------------------------------------------
script_cmd_random_goto:

    LC = LC + 2
    if (rnd(1) * 100) < D then
        LC = 2050 + 1448 + 2 * D2
        goto check_end_of_script_cmd
    end if
    goto check_end_of_script_cmd

' -----------------------------------------------------
script_cmd_change_tile_script:

    WG = D + 220
    goto script_wait_return_key

' -----------------------------------------------------
check_end_of_script_cmd:

    print
    print
    if J = 1 and peek(37) < 15 then
        goto next_cmd_or_end_script
    end if

' -----------------------------------------------------
script_wait_return_key:

    vtab 23
    htab 15
    print "PRESS RETURN" ;
    get A$
    if asc(A$) <> 13 then
        goto script_wait_return_key
    end if
    home

    ' Win what ?
    if X = 23 then
        &run "WIN"
    end if

    if MO > 0 then
        goto start_encounter_system
    end if

    ' Rerun script
    if X = 22 then
        goto tile_run_script
    end if

next_cmd_or_end_script:

    ' end of script
    if J = 0 then
        goto command_prompt
    end if
    LC = LC + 2
    goto read_next_cmd

sub_8640:

    M1 = M7
    if M1 = 0 then
        return
    end if

' -----------------------------------------------------
display_special_message:

    TM = 3750 + 40 * M1
    ' store address
    poke 804, TM / 256
    poke 803, TM - 256 * peek(804)
    call 800
    return

' -----------------------------------------------------
display_party_health:

    text
    home
    vtab 4
    print tab(11) "---PARTY HEALTH---"
    vtab 8
    print S$
    print " # NAME" tab(16) "MAGIC  HIT PTS  STATUS"
    print S$
    for PM = 0 to cur_characters
        print " " PM + 1 " " character_names(PM) tab(16) get_character_data(CHARACTER_CURRENT_MAGIC) "/" get_character_data(CHARACTER_MAX_MAGIC) tab(23) get_character_data(CHARACTER_CURRENT_HIT_POINTS) "/" get_character_data(CHARACTER_MAX_HIT_POINTS) tab(32) S$(get_character_data(CHARACTER_STATUS))
    next
    print S$
    vtab 23
    get A$
    goto command_prompt

lbl_9500:

    ER = peek(222)
    if ER = 254 then
        resume
    end if

lbl_9505:

    text
    home
    print "ERROR # " ER
    goto lbl_9505
