' -----------------------------------------------------
' Phantasie II
' Main menu
' -----------------------------------------------------
' Decoded and commented by Franck Charlet
' -----------------------------------------------------

main_menu:

    ' Load saved games file at 0x2021 / 8225
    &recall "CHAR2"
    O$ = ""
    ' Check if there's characters in roster file
    Old = 8225 + 59
    ' (only check 36 characters ?)
    for I = 0 to 36
        if peek(Old + I * 170) = 0 then
        next I
        Old = 0
        O$ = " (NONE)"
    end if
    poke 232, 31
    poke 233, 69
    scale = 2
    on err goto display_main_menu
    &recall "SHAPES"            ' 0x451f / 17695
    &recall "INFO"              ' 0x302 / 770

display_main_menu:

    home
    text
    home
    poke 0xC053, 0              ' MIXSET
    print
    print " PHANTASIE II" ; tab(25) ; "COPYRIGHT 1986"
    print " VERSION 1.11" ; tab(33) ; "2/5/86"
    print
    print
    print "       BY WINSTON DOUGLAS WOOD"
    print
    L$ = " -------------------------------------"
    print L$
    print "    CRACKED BY HALF-TRACKER/L.S.D."
    print "    THANX: DIGITAL MONK, SECTOR 17,"
    print tab(11) ; "AND THE DUPLICATOR"
    print tab(10) "2003 MOD BY CEA2 GUYS"
    print L$
    vtab 17
    print " 1 - START IN PIPPACOTT"
    print " 2 - CONTINUE SAVED GAME" O$
    print " 3 - DEMO"
    for Y = 17575 to 17694
        poke Y, 0
    next

ask_title_choice:

    vtab 22
    print " SELECT OPTION: " ;
    get A$
    A = val(A$)
    htab 1
    if A < 1 or A > 3 then
        goto ask_title_choice
    end if
    ' Old = 0 if there wasn't any game saved
    if Old = 0 and A = 2 then
        goto ask_title_choice
    end if
    ' Save user response for later
    poke 17581, A
    for X = 17405 to 17574
        poke X, 7
    next
    poke 17464, 0
    poke 17574, 26
    poke 17589, 4
    if A < 3 then
        &run "TOWN"
    end if
    ' Demo mode
    &run "DEMO"
