' -----------------------------------------------------
' Phantasie II
' Astral plane
' -----------------------------------------------------
' Decoded and commented by Franck Charlet
' -----------------------------------------------------

death:

    home
    call 0xF3F2         ' HCLR
    D$ = chr$(4)
    SA = 16385

    def get_character_data(X) = peek(SA + 170 * PM + X)
    def character_data_address(X) = SA + 170 * PM + X

    cur_characters = peek(SA + CHARACTERS_IN_PARTY)
    for PM = 0 to 6
        for X = CHARACTER_NAME to CHARACTER_NAME + 9
            Y = get_character_data(X)
            if Y = 13 then
                goto lbl_340
            end if
            character_names(PM) = character_names(PM) + chr$(Y)
        next X

lbl_340:

    next PM

    hcolor = 3
    scale = 2
    rot = 8
    draw 19 at 200, 140
    draw 19 at 201, 140
    rot = 0
    hcolor = 2
    scale = 1
    draw 7 at 226, 140
    draw 7 at 227, 140
    scale = 2
    hcolor = 3
    draw 19 at 240, 0
    hplot 0, 159 to 279, 159
    hplot 0, 0 to 279, 0
    rot = 32
    scale = 1
    draw 19 at 50, 100
    draw 21 at 50, 100
    rot = 16
    draw 19 at 180, 80
    draw 22 at 180, 80
    rot = 56
    draw 19 at 75, 125
    draw 20 at 75, 125
    scale = 2
    rot = 48
    draw 19 at 100, 170
    rot = 36
    draw 19 at 180, 100
    draw 19 at 181, 100
    rot = 0
    scale = 1
    hcolor = 2
    draw 7 at 130, 136
    draw 7 at 131, 136
    scale = 2
    hcolor = 3
    draw 19 at 130, 0
    vtab 24
    print "YOUR PARTY HAS BEEN DEFEATED,"
    print "THE MONSTERS JUMP FOR JOY."
    scale = 1
    poke 0xC050, 0
    for Y = 1 to 70
        for X = 100 to 160 step 30
            xdraw 6 at X, 40
            draw 5 at X, 50
        next
        for X = 100 to 160 step 30
            xdraw 5 at X, 50
            draw 6 at X, 40
        next
    next Y
    call 62450
    text
    home
    hplot 0, 159 to 100, 100 to 179, 100 to 279, 159
    hplot 100, 100 to 100, 10 to 179, 10 to 179, 100
    for X = 65 to 185 step 140 / (cur_characters + 1)
        draw 19 at X, 159
        draw 20 at X, 159
    next
    hcolor = 6
    scale = 3
    draw 11 at 49, 100
    draw 11 at 185, 100
    draw 11 at 48, 100
    draw 11 at 184, 100
    poke -16304, 0
    vtab 24
    print "YOU HAVE ARRIVED ON THE ASTRAL PLANE!!!"
    for PS = 1 to 9000
    next
    hcolor = 2
    scale = 4
    draw 18 at 120, 90
    home
    vtab 24
    print "A GREAT DEMON APPEARS AND SPEAKS..."
    for PS = 1 to 7000
    next
    for PM = 0 to cur_characters
        print character_names(PM) " YOU HAVE BEEN " ;
        if get_character_data(CHARACTER_CONSTITUTION) < 1 then
            goto character_destroyed
        end if
        if get_character_data(CHARACTER_LEVEL) > rnd(1) * 4 + 2 then
            goto character_resurrected
        end if
        if get_character_data(CHARACTER_LEVEL) > rnd(1) * 3 then
            goto character_undead
        end if

character_destroyed:

        print "DESTROYED"
        for X = CHARACTER_STRENGTH to CHARACTER_LEVEL
            poke character_data_address(X), 0
        next
        goto lbl_1500

character_resurrected:

        print "RESURRECTED"
        poke character_data_address(CHARACTER_STATUS), CHARACTER_STATUS_OKAY
        poke character_data_address(CHARACTER_CURRENT_HIT_POINTS), get_character_data(CHARACTER_MAX_HIT_POINTS)
        poke character_data_address(CHARACTER_GOLD_HI), 0
        goto lbl_1500

character_undead:

        print
        print "GRANTED UNDEAD STATUS"
        poke character_data_address(CHARACTER_LEVEL), 20
        poke character_data_address(CHARACTER_RACE), 15
        poke character_data_address(CHARACTER_STATUS), CHARACTER_STATUS_OKAY
        poke character_data_address(CHARACTER_CURRENT_HIT_POINTS), get_character_data(CHARACTER_MAX_HIT_POINTS)

lbl_1500:

        poke 0xC010, 0
        get A$
        home
        vtab 24
    next PM

    for X = 1190 to 1200
        poke SA + X, 0
    next
    poke SA + 1192, 14
    poke SA + 1193, 7
    poke SA + 1191, 18
    hgr
    &run "OUTDOORS"
