' -----------------------------------------------------
' Phantasie II
' Won
' -----------------------------------------------------
' Decoded and commented by Franck Charlet
' -----------------------------------------------------

sub_10:

    text
    home
    call 62450
    vtab 7
    print "     THE PARTY IS SUDDENLY TELEPORTED   INTO A SMALL ROOM.  FILMON THE SAGE     GREETS YOU AND TELLS YOU THAT YOU ARE   HEROES OF FERRONRAH."
    print
    print "     FILMON TELLS YOU THAT SINCE YOU    HAVE DESTROYED THE ORB THE CURSE OF     NIKADEMUS WILL " ;
    inverse
    print "SLOWLY" ;
    normal
    print " FADE FROM THE     LAND."
    print
    print "     HE LEADS YOU INTO A SMALL ROOM     CROWDED WITH PEOPLE."
    V$(0) = "MAGNIFICENT"
    V$(1) = "MIGHTY"
    V$(2) = "COURAGEOUS"
    V$(3) = "POWERFUL"
    V$(4) = "BOLD"
    V$(5) = "DARING"
    V$(6) = "GALLANT"
    V$(7) = "AWESOME"
    V$(8) = "VALIANT"
    V$(9) = "SUPERB"
    R$(0) = "GELNOR"
    R$(1) = "FERRONRAH"
    R$(2) = "THE NETHERWORLD"
    SA = 16385
    def fn P(X) = peek(SA + 170 * PM + X)
    cur_characters = peek(SA + CHARACTERS_IN_PARTY)
    for PM = 0 to 5
        for X = 131 to 150
            Y = fn P(X)
            if Y = 0 then
                goto lbl_66
            end if
            A$(PM) = A$(PM) + chr$(Y)
        next X

lbl_66:

    next PM
    Q = 4
    N = 50
    dim X(N), Y(N), J(Q)
    for X = 1 to N
        read X(X), Y(X)
    next
    data  0,  21, 19,  20,  42,  22,  62,  19, 80,  20,  99,  23, 122,  22, 142,  21, 160, 21, 181, 19, 203, 20, 221, 22, 239, 19, 260, 20
    data  0,  50, 20,  51,  39,  51,  62,  49, 80,  50,  99,  52, 121,  49, 140,  49, 161, 50, 180, 52, 202, 49, 220, 50, 240, 50, 261, 52
    data  1,  80, 19,  83,  42,  81,  60,  77, 79,  81, 101,  81, 120,  80, 142,  78, 162, 79, 179, 82, 200, 80, 219, 82, 240, 81, 259, 79
    data  0, 110, 19, 111, 242, 110, 261, 109,  0, 140,  19, 139, 241, 141, 260, 140
    hcolor = 3
    scale = 2
    for Y = 153 to 159
        hplot 25, Y to 256, Y
    next
    for Y = 147 to 159
        hplot 33, Y to 248, Y
    next
    hplot 0, 159 to 279, 159
    for Y = 141 to 159
        hplot 41, Y to 240, Y
    next
    for PM = 0 to cur_characters
        draw fn P(168) at 38 + 32 * PM, 140
        draw 20 at 38 + 32 * PM, 140
    next
    scale = 1
    goto lbl_3000

sub_2000:

    T = J(JM)
    hcolor = 0
    draw 2 at X(T), Y(T) - 7
    hcolor = 3
    draw 1 at X(T), Y(T)
    T = int(rnd(1) * N + 1)
    J(JM) = T
    hcolor = 0
    draw 1 at X(T), Y(T)
    hcolor = 3
    draw 2 at X(T), Y(T) - 7
    JM = JM + 1
    if JM > Q then
        JM = 1
    end if
    return

sub_2500:

    for X = 1 to Q
        J(X) = int(rnd(1) * N + 1)
        hcolor = 0
        draw 1 at X(J(X)), Y(J(X))
        hcolor = 3
        draw 2 at X(J(X)), Y(J(X)) - 7
    next
    JM = 1
    return

sub_2600:

    for X = 1 to Q
        hcolor = 0
        draw 2 at X(J(X)), Y(J(X)) - 7
        hcolor = 3
        draw 1 at X(J(X)), Y(J(X))
    next
    return

sub_2700:

    for X = 1 to N
        draw 2 at X(X), Y(X)
    next
    return

sub_2800:

    for X = 1 to N
        hcolor = 0
        draw 2 at X(X), Y(X)
        hcolor = 3
        draw 1 at X(X), Y(X)
        I = peek(-16336)
        for PS = 1 to 333
        next
    next
    return

sub_2900:

    for PS = 1 to 2000
    next
    htab 10
    flash
    print "THE CROWD GOES WILD!" ;
    normal
    gosub sub_2500
    for A = 1 to JP
        gosub sub_2000
    next
    gosub sub_2600
    return

lbl_3000:

    gosub sub_2700
    vtab 23
    htab 12
    gosub ask_press_return
    poke -16304, 0
    home
    gosub sub_2800
    for PS = 1 to 500
    next
    JP = 150
    vtab 22
    print "FILMON SPEAKS:"
    print "  'PRESENTING THE HEROES OF FERRONRAH'"
    gosub sub_2900
    JP = 57
    home
    for PS = 1 to 2000
    next
    for PM = 0 to cur_characters
        home
        for PS = 1 to 2000
        next
        vtab 21
        htab 20 - (len(A$(PM)) / 2)
        print A$(PM)
        V$ = V$(rnd(1) * 10)
        htab 16 - (len(V$) / 2)
        print "THE " V$ " ONE"
        R$ = "FROM " + R$(fn P(40))
        htab 20 - (len(R$) / 2)
        print R$
        scale = 2
        Z = 38 + 32 * PM
        hcolor = 0
        draw 20 at Z, 140
        hcolor = 3
        draw 21 at Z, 140
        scale = 1
        gosub sub_2900
        scale = 2
        hcolor = 0
        draw 21 at Z, 140
        hcolor = 3
        draw 20 at Z, 140
        vtab 24
        htab 2
        print spc(23) ;
        gosub ask_press_return
    next
    home
    for PS = 1 to 3000
    next
    home
    vtab 22
    print "FILMON SPEAKS: 'THEY WILL EACH RECEIVE   A WAND OF FILMON WHICH HAS GREAT POWER  BUT CAN ONLY BE USED ONCE' (PRESS RET)" ;
    gosub wait_return_key
    hgr
    text
    home
    print "FILMON ADDRESSES THE CROWD IN A SOLEMN  VOICE:"
    print
    print "  'NIKADEMUS HAS NOW SUFFFERED LOSSES ONTHE ISLANDS OF GELNOR AND FERRONRAH. NOWCOMES THE TIME FOR THE ULTIMATE BATTLE  BETWEEN GOOD AND EVIL."
    print "   NIKADEMUS AND THE FULL FORCE OF HIS  ARMY ARE AT THIS MINUTE MARCHING ON THE GREAT CONTINENT TO THE NORTH.  IT IS A  STRANGE PLACE WITH DIFFERENT CREATURES, DIFFERENT WEAPONS, AND EVEN DIFFERENT   MAGIC."
    print "   IF THE GREAT NORTHERN CONTINENT FALLSWE ARE ALL DOOMED. THESE " cur_characters + 1 " BRAVE ADVEN-"
    print "TURERS MUST TRAVEL THERE AND CONFRONT"
    print "NIKADEMUS."
    print "   WHEN THEY ARE READY FOR THE THIRD ANDFINAL INSTALLMENT IN THE BATTLE AGAINST EVIL, THE EVIL WILL SURELY BE READY FOR THEM.'"
    print
    print "FILMON TELEPORTS THE PARTY.   THE END."
    htab 10
    gosub ask_press_return
    for X = 1210 to 1210 + cur_characters
        poke SA + X, 149
    next
    if peek(SA + 1269) = 0 then
        poke SA + 1269, 4
    end if

    poke SA + 1191, 1

    &run "TOWN"

ask_press_return:

    print "(PRESS RETURN)" ;

wait_return_key:

    poke -16368, 0
    get A$
    if asc(A$) <> 13 then
        goto wait_return_key
    end if
    return
